#include "ttl_p.h"


TtIniFile::TtIniFile() {
  this->file_name = NULL;
  
  char buf[MAX_PATH];
  TtPath::get_exec_file_name( buf, sizeof( buf ) );
  TtPath::edit_path( buf, true, true, true, false );
  strcat( buf, ".ini" );
  this->set_file_name( buf );
}

TtIniFile::TtIniFile( const char *file_name ) {
  this->file_name = NULL;
  
  this->set_file_name( file_name );
}

TtIniFile::~TtIniFile() {
  this->flush();
  if ( this->file_name != NULL ) { delete [] this->file_name; }
}

const char *TtIniFile::get_file_name() {
  return this->file_name;
}

void TtIniFile::set_file_name( const char *file_name ) {
  if ( this->file_name != NULL ) { delete [] this->file_name; }
  this->file_name = new char[strlen( file_name ) + 1];
  strcpy( this->file_name, file_name );
}

TtIniSection *TtIniFile::get_section( char *name ) {
  return new TtIniSection( this, name );
}

void TtIniFile::flush() {
  WritePrivateProfileString( NULL, NULL, NULL, this->file_name );
}
