// t@C֘ANX
#ifndef _TTFILE_H_
#define _TTFILE_H_

// -- TtPath -------------------------------------------------------------
namespace TtPath {
  // Ȃ
  bool is_directory(  const char *path );
  bool is_file_spec(  const char *path );
  bool is_relative(   const char *path );
  bool is_rooted(     const char *path );
  bool match_spec( const char *path, const char *match );

  bool file_exists(   const char *path );

  // Ȃ
  char *find_filename( const char *path );
  char *find_extension( const char *path );

  // ҏWȂ
  void edit_path( char *target, bool f_drive, bool f_dir, bool f_fname, bool f_ext );
  bool compact_path( char *dest, const char *src, int max );
  void quote_if_has_spaces( char *path );

  // 擾Ȃ
  void get_exec_file_name( char *buf, int max );
  bool get_expand_path( const char *path, char *buf, int buf_size );
}

// -- TtIniFile ----------------------------------------------------------
class TtIniFile {

  // -- instance ---------------------------------------------------------
protected:
  char *file_name;

  ~TtIniFile();

public:

  // ftHg exe Ɠt@C .ini ̃t@C
  TtIniFile();
  TtIniFile( const char *file_name );

  const char *get_file_name();
  void set_file_name( const char *file_name );

  TtIniSection *get_section( char *name );

  void flush();
};


// -- TtIniSection -------------------------------------------------------
class TtIniSection {
  friend TtIniFile;

  // -- instance ---------------------------------------------------------
protected:
  TtIniFile *ini_file;
  char *name;

  TtIniSection( TtIniFile *ini_file, const char *name );

public:

  ~TtIniSection();

  TtIniFile *get_ini_file();

  const char *get_name();
  void set_name( const char *name );
  
  int get_int( const char *key );
  int get_int( const char *key, int default_int );
  int get_str( const char *key, char *buf, int buf_size );
  int get_str( const char *key, char *buf, int buf_size, const char *default_str );

  bool set_int( const char *key, int data );
  bool set_str( const char *key, const char *data );

  void flush();
};

#endif // _TTFILE_H_
