// WIN32  EBhE֘ÃNX
#ifndef _TTWINDOWSUB_H_
#define _TTWINDOWSUB_H_

// -- TtMenu -------------------------------------------------------------
class TtMenu {
protected:
  TtWindow *parent;
  HMENU menu;
  bool loaded;

public:

  TtMenu( TtWindow *parent );
  TtMenu( TtMenu *root, int index );
  ~TtMenu();

  bool load( const char *name );

  HMENU get_handle();
  void set_handle( HMENU menu );

  HMENU get_sub_at( int index );

  void track_popup( int x, int y );
  void track_popup_relative( int x, int y );
  int track_popup( int x, int y, int flags, RECT *rect );

};


// -- TtImageList --------------------------------------------------------
class TtImageList {
protected:
  HIMAGELIST list;

public:
  TtImageList( int width, int height );
  TtImageList( int width, int height, int flags );
  TtImageList( int width, int height, int flags, int initial, int grow );
  ~TtImageList();

  HIMAGELIST get_handle();

  int add_icon( HICON icon );
  int add_bitmap( TtBmpImage *image );
  int add_bitmap( TtBmpImage *image, TtBmpImage *mask );
  int add_bitmap_masked( TtBmpImage *image );
  int add_bitmap_masked( TtBmpImage *image, int mask_color );
};

// -- TtBmpImage ---------------------------------------------------------
class TtBmpImage {
public:
  static const int OLD_CLOSE;
  static const int SIZE;
  static const int OLD_UPARROW;
  static const int OLD_DNARROW;
  static const int OLD_RGARROW;
  static const int OLD_LFARROW;
  static const int BTSIZE;
  static const int CHECK;
  static const int CHECKBOXES;
  static const int BTNCORNERS;
  static const int OLD_REDUCE;
  static const int OLD_ZOOM;
  static const int OLD_RESTORE;
  static const int CLOSE;
  static const int UPARROW;
  static const int DNARROW;
  static const int RGARROW;
  static const int LFARROW;
  static const int REDUCE;
  static const int ZOOM;
  static const int RESTORE;
  static const int REDUCED;
  static const int ZOOMD;
  static const int RESTORED;
  static const int UPARROWD;
  static const int DNARROWD;
  static const int RGARROWD;
  static const int LFARROWD;
  static const int MNARROW;
  static const int COMBO;
  static const int UPARROWI;
  static const int DNARROWI;
  static const int RGARROWI;
  static const int LFARROWI;

  static const int ERROR_SYSTEM;
  static const int ERROR_FILE_OPEN;
  static const int ERROR_FILE_READ;
  static const int ERROR_NOT_BITMAP;

  
protected:
  HBITMAP bmp;
  bool loaded;
  int error_id;
  
public:
  TtBmpImage( int id );
  TtBmpImage( const char *path );
  TtBmpImage( HINSTANCE h_instance, const char *class_name );
  ~TtBmpImage();

  bool is_loaded();
  int get_load_error();
  
  HBITMAP get_handle();

  int get_width();
  int get_height();
};

#endif // _TTWINDOWSUB_H_
