#include "ttl_p.h"

char *TtApp::class_name = "TTAPP";

bool TtApp::init( HINSTANCE h_instance ) {
  // EBhENX̍쐬Ao^
  WNDCLASS window_class;
  window_class.style         = CS_HREDRAW | CS_VREDRAW;
  window_class.lpfnWndProc   = _ttl_wnd_proc;
  window_class.cbClsExtra    = 0;
  window_class.cbWndExtra    = 0;
  window_class.hInstance     = h_instance;
  window_class.hIcon         = LoadIcon( NULL , IDI_APPLICATION );
  window_class.hCursor       = LoadCursor( NULL, IDC_ARROW );
  window_class.hbrBackground = (HBRUSH)(COLOR_MENU + 1);
  window_class.lpszMenuName  = NULL;
  window_class.lpszClassName = TtApp::class_name;

  return RegisterClass( &window_class );
}

DWORD  TtApp::get_ex_style()   { return 0; }
DWORD  TtApp::get_style()      { return WS_OVERLAPPEDWINDOW; }
PCTSTR TtApp::get_class_name() { return TtApp::class_name; }

bool TtApp::created() { return true; }

LRESULT TtApp::wm_command_recved( int id, int code, HWND child ) {
  id; code; child; // x}~̈
  return TtWindow::MSG_DEFAULT;
}

LRESULT TtApp::wm_notify_recved( int id, NMHDR *nmhdr ) {
  id; nmhdr; // x}~̈
  return TtWindow::MSG_DEFAULT;
}

LRESULT TtApp::wm_size_recved( int flag, int width, int height ) {
  flag; width; height; // x}~̈
  return TtWindow::MSG_DEFAULT;
}

LRESULT TtApp::wm_destroy_recved() {
  PostQuitMessage(0);
  return 0;
}


LRESULT TtApp::wnd_proc( UINT msg, WPARAM w_param, LPARAM l_param ) {
  LRESULT ret;
  switch ( msg ) {
  case WM_DESTROY:
    ret = this->wm_destroy_recved();
    if ( ret != TtWindow::MSG_DEFAULT ) { return ret; } else { break; }

  case WM_COMMAND:
    ret = this->wm_command_recved( LOWORD( w_param ), HIWORD( w_param ), (HWND)l_param );
    if ( ret != TtWindow::MSG_DEFAULT ) { return ret; } else { break; }

  case WM_NOTIFY:
    ret = this->wm_notify_recved( w_param, (NMHDR *)l_param );
    if ( ret != TtWindow::MSG_DEFAULT ) { return ret; } else { break; }

  case WM_SIZE:
    ret = this->wm_size_recved( w_param, LOWORD( l_param ), HIWORD( l_param ) );
    if ( ret != TtWindow::MSG_DEFAULT ) { return ret; } else { break; }

  case WM_HSCROLL:
    ret = this->wm_hscroll_recved( LOWORD( w_param ), HIWORD( w_param ), (HWND)l_param );
    if ( ret != TtWindow::MSG_DEFAULT ) { return ret; } else { break; }

  case WM_VSCROLL:
    ret = this->wm_vscroll_recved( LOWORD( w_param ), HIWORD( w_param ), (HWND)l_param );
    if ( ret != TtWindow::MSG_DEFAULT ) { return ret; } else { break; }

  }
  return TtWindow::wnd_proc( msg, w_param, l_param );
}

LRESULT TtApp::wm_hscroll_recved( int code, int position, HWND h_wnd ) {
  if ( h_wnd != this->h_wnd ) {
    return TtWindow::find_window( h_wnd )->wm_hscroll_recved( code, position, h_wnd );
  }
  return TtWindow::MSG_DEFAULT;
}

LRESULT TtApp::wm_vscroll_recved( int code, int position, HWND h_wnd ) {
  if ( h_wnd != this->h_wnd ) {
    return TtWindow::find_window( h_wnd )->wm_vscroll_recved( code, position, h_wnd );
  }
  return TtWindow::MSG_DEFAULT;
}
