#include "ttl_p.h"

DWORD  TtScroll::get_style()      { return 0; }
DWORD  TtScroll::get_ex_style()   { return 0; }
PCTSTR TtScroll::get_class_name() { return "SCROLLBAR"; }

DWORD  TtScrollV::get_style()   { return SBS_VERT; }
DWORD  TtScrollH::get_style()   { return SBS_HORZ; }

LRESULT TtScrollV::wm_vscroll_recved( int code, int position, HWND h_wnd ) {
  h_wnd; // x}~̈
  return this->scrolling( code, position );
}

LRESULT TtScrollH::wm_hscroll_recved( int code, int position, HWND h_wnd ) {
  h_wnd; // x}~̈
  return this->scrolling( code, position );
}

LRESULT TtScroll::scrolling( int code, int position ) {
  this->get_info();
  switch ( code ) {
  case SB_LEFT:
    this->info.nPos = this->info.nMin;
    break;

  case SB_RIGHT:
    this->info.nPos = this->info.nMax;
    break;

  case SB_LINELEFT:
    if ( this->info.nPos > this->info.nMin ) {
      this->info.nPos -= 1;
    }
    break;

  case SB_LINERIGHT:
    if ( this->info.nPos < this->info.nMax - 1 ) {
      this->info.nPos += 1;
    }
    break;

  case SB_PAGELEFT:
    this->info.nPos -= this->info.nPage;
    if ( this->info.nPos < this->info.nMin ) {
      this->info.nPos = this->info.nMin;
    }
    break;

  case SB_PAGERIGHT:
    this->info.nPos += this->info.nPage;
    if ( this->info.nPos > this->info.nMax ) {
      this->info.nPos = this->info.nMax;
    }
    break;

  case SB_THUMBPOSITION:
    this->info.nPos = position;
    break;

  default:
    return TtWindow::MSG_DEFAULT;
  }
  this->set_info();
  return 0;
}

int TtScroll::get_track_position() {
  this->get_info();
  return this->info.nPos;
}

void TtScroll::set_track_position( int position ) {
  this->get_info();
  this->info.nPos = position;
  this->set_info();
}

int TtScroll::get_max() {
  this->get_info();
  return this->info.nMax;
}

void TtScroll::set_max( int max ) {
  this->get_info();
  this->info.nMax = max;
  this->set_info();
}

int TtScroll::get_min() {
  this->get_info();
  return this->info.nMin;
}

void TtScroll::set_min( int min ) {
  this->get_info();
  this->info.nMin = min;
  this->set_info();
}

void TtScroll::set_range( int min, int max ) {
  this->get_info();
  this->info.nMin = min;
  this->info.nMax = max;
  this->set_info();
}

int TtScroll::get_page_size() {
  this->get_info();
  return this->info.nPage;
}

void TtScroll::set_page_size( int page_size ) {
  this->get_info();
  this->info.nPage = page_size;
  this->set_info();
}

bool TtScroll::get_info() {
  info.fMask = SIF_ALL;
  return GetScrollInfo( this->h_wnd, SB_CTL, &info );
}

void TtScroll::set_info() {
  info.fMask |= SIF_DISABLENOSCROLL;
  SetScrollInfo( this->h_wnd, SB_CTL, &info, TRUE );
}
