#include "ttl_p.h"

const int TtBmpImage::OLD_CLOSE   = 32767;
const int TtBmpImage::SIZE        = 32766;
const int TtBmpImage::OLD_UPARROW = 32765;
const int TtBmpImage::OLD_DNARROW = 32764;
const int TtBmpImage::OLD_RGARROW = 32763;
const int TtBmpImage::OLD_LFARROW = 32762;
const int TtBmpImage::BTSIZE      = 32761;
const int TtBmpImage::CHECK       = 32760;
const int TtBmpImage::CHECKBOXES  = 32759;
const int TtBmpImage::BTNCORNERS  = 32758;
const int TtBmpImage::OLD_REDUCE  = 32757;
const int TtBmpImage::OLD_ZOOM    = 32756;
const int TtBmpImage::OLD_RESTORE = 32755;
const int TtBmpImage::CLOSE       = 32754;
const int TtBmpImage::UPARROW     = 32753;
const int TtBmpImage::DNARROW     = 32752;
const int TtBmpImage::RGARROW     = 32751;
const int TtBmpImage::LFARROW     = 32750;
const int TtBmpImage::REDUCE      = 32749;
const int TtBmpImage::ZOOM        = 32748;
const int TtBmpImage::RESTORE     = 32747;
const int TtBmpImage::REDUCED     = 32746;
const int TtBmpImage::ZOOMD       = 32745;
const int TtBmpImage::RESTORED    = 32744;
const int TtBmpImage::UPARROWD    = 32743;
const int TtBmpImage::DNARROWD    = 32742;
const int TtBmpImage::RGARROWD    = 32741;
const int TtBmpImage::LFARROWD    = 32740;
const int TtBmpImage::MNARROW     = 32739;
const int TtBmpImage::COMBO       = 32738;
const int TtBmpImage::UPARROWI    = 32737;
const int TtBmpImage::DNARROWI    = 32736;
const int TtBmpImage::RGARROWI    = 32735;
const int TtBmpImage::LFARROWI    = 32734;

const int TtBmpImage::ERROR_SYSTEM     = 1;
const int TtBmpImage::ERROR_FILE_OPEN  = 2;
const int TtBmpImage::ERROR_FILE_READ  = 3;
const int TtBmpImage::ERROR_NOT_BITMAP = 4;

TtBmpImage::TtBmpImage( int id ) {
  this->loaded = false;
  this->error_id = 0;
  this->bmp = LoadBitmap( NULL, (const char *)id );
  if ( this->bmp != NULL ) { this->loaded = true; }
  else { this->error_id = TtBmpImage::ERROR_SYSTEM; }
}

TtBmpImage::TtBmpImage( const char *path ) {
  int readed;
  char *buf = NULL;

  // t@CJ
  FILE *file = fopen( path, "rb" );
  if ( file == NULL ) {
    this->error_id = TtBmpImage::ERROR_FILE_OPEN;
    goto ERR;
  }

  // wb_ǂݍ
  BITMAPFILEHEADER file_header;
  readed = fread( (char *)&file_header, 1, sizeof( BITMAPFILEHEADER ), file );
  if ( readed < sizeof( BITMAPFILEHEADER ) ) {
    this->error_id = TtBmpImage::ERROR_FILE_READ;
    goto ERR;
  }

  // t@C̐擪 BM ł͖ꍇ
  if ( file_header.bfType != 0x4d42 ) {
    this->error_id = TtBmpImage::ERROR_NOT_BITMAP;
    goto ERR;
  }

  // t@Cǂݍ
  int buf_size;
  buf_size = file_header.bfSize - sizeof( BITMAPFILEHEADER );
  buf = new char[buf_size];
  readed = fread( buf, 1, buf_size, file );
  if ( readed < buf_size ) {
    {
      char buf[1000];
      sprintf( buf, "%d %d %d %d %d",file_header.bfSize, sizeof( BITMAPFILEHEADER ), buf_size, readed, feof( file ) );
      MessageBox( 0,buf,buf,0);
    }
    this->error_id = TtBmpImage::ERROR_FILE_READ;
    goto ERR;
  }

  this->bmp = CreateBitmap( ((BITMAPINFOHEADER *)buf)->biWidth,
                            ((BITMAPINFOHEADER *)buf)->biHeight,
                            ((BITMAPINFOHEADER *)buf)->biPlanes,
                            ((BITMAPINFOHEADER *)buf)->biBitCount,
                            buf + ( file_header.bfOffBits - sizeof( BITMAPFILEHEADER ) ) );
  if ( this->bmp == NULL ) {
    this->loaded = false;
    this->error_id = TtBmpImage::ERROR_SYSTEM;
    goto ERR;
  }
  this->loaded = true;
  this->error_id = 0;

  delete [] buf;
  fclose( file );
  return;

ERR:
  if ( file != NULL ) { fclose( file ); }
  if ( buf != NULL ) { delete [] buf; }
  this->loaded = false;
}

TtBmpImage::TtBmpImage( HINSTANCE h_instance, const char *class_name ) {
  this->loaded = false;
  this->error_id = 0;
  this->bmp = LoadBitmap( h_instance, class_name );
  if ( this->bmp != NULL ) { this->loaded = true; }
  else { this->error_id = TtBmpImage::ERROR_SYSTEM; }
}

TtBmpImage::~TtBmpImage() {
  if ( this->loaded ) { DeleteObject( this->bmp ); }
}

bool TtBmpImage::is_loaded() {
  return this->loaded;
}

int TtBmpImage::get_load_error() {
  return this->error_id;
}

HBITMAP TtBmpImage::get_handle() {
  return this->bmp;
}

int TtBmpImage::get_width() {
  BITMAP temp;
  GetObject( this->bmp, sizeof( BITMAP ), &temp );
  return temp.bmWidth;
}

int TtBmpImage::get_height() {
  BITMAP temp;
  GetObject( this->bmp, sizeof( BITMAP ), &temp );
  return temp.bmHeight;
}
