#include "ttl_p.h"

TtImageList::TtImageList( int width, int height ) {
  this->list = ImageList_Create( width, height, ILC_COLOR | ILC_MASK, 1, 1 );
}
TtImageList::TtImageList( int width, int height, int flags ) {
  this->list = ImageList_Create( width, height, flags, 1, 1 );
}
TtImageList::TtImageList( int width, int height, int flags, int initial, int grow ) {
  this->list = ImageList_Create( width, height, flags, initial, grow );
}

TtImageList::~TtImageList() {
  ImageList_Destroy( this->list );
}

HIMAGELIST TtImageList::get_handle() {
  return this->list;
}

int TtImageList::add_icon( HICON icon ) {
  return ImageList_AddIcon( this->list, icon );
}

int TtImageList::add_bitmap( TtBmpImage *image ) {
  return ImageList_Add( this->list, image->get_handle(), NULL );
}
int TtImageList::add_bitmap( TtBmpImage *image, TtBmpImage *mask ) {
  return ImageList_Add( this->list, image->get_handle(), mask->get_handle() );
}

int TtImageList::add_bitmap_masked( TtBmpImage *image ) {
  return ImageList_AddMasked( this->list, image->get_handle(), 0 );
}
int TtImageList::add_bitmap_masked( TtBmpImage *image, int mask_color ) {
  return ImageList_AddMasked( this->list, image->get_handle(), mask_color );
}
