#include "ttl_p.h"

TtMenu::TtMenu( TtWindow *parent ) {
  this->parent = parent;
  this->menu = NULL;
  this->loaded = false;
}

TtMenu::TtMenu( TtMenu *root, int index ) {
  this->parent = root->parent;
  this->menu = root->get_sub_at( index );
  this->loaded = false;
}

bool TtMenu::load( const char *name ) {
  if ( this->loaded ) { DestroyMenu( this->menu ); }
  this->menu = LoadMenu( this->parent->get_h_instance(), name );
  this->loaded = this->menu != NULL;
  return this->menu != NULL;
}

TtMenu::~TtMenu() {
  if ( this->loaded ) { DestroyMenu( this->menu ); }
}

HMENU TtMenu::get_handle() {
  return this->menu;
}

HMENU TtMenu::get_sub_at( int index ) {
  return GetSubMenu( this->menu, index );
}

void TtMenu::track_popup( int x, int y ) {
  this->track_popup( x, y, TPM_LEFTALIGN | TPM_TOPALIGN, NULL );
}

void TtMenu::track_popup_relative( int x, int y ) {
  POINT point;
  point.x = x;
  point.y = y;
  ClientToScreen( this->parent->get_h_wnd() , &point );
  this->track_popup( point.x, point.y );
}

int TtMenu::track_popup( int x, int y, int flags, RECT *rect ) {
  return TrackPopupMenu( this->menu, flags, x, y, 0, this->parent->get_h_wnd(), rect );
}

